unit RichPreview;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Richprint,Buttons, StdCtrls, arrowbtn,ComCtrls, Printers, Mask;

type
  TRichPreviewForm = class(TForm)
    Panel1: TPanel;
    ArrowButton2: TArrowButton;
    Label1: TLabel;
    Bevel1: TBevel;
    Label2: TLabel;
    Bevel2: TBevel;
    SpeedButton1: TSpeedButton;
    BitBtn1: TBitBtn;
    Bevel3: TBevel;
    Bevel5: TBevel;
    Label4: TLabel;
    Label5: TLabel;
    ArrowButton1: TArrowButton;
    PrintDialog1: TPrintDialog;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    MaskEdit1: TMaskEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label3: TLabel;
    Label9: TLabel;
    Bevel4: TBevel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure ArrowButton2Click(Sender: TObject);
    procedure ArrowButton1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure MaskEdit1Change(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Label7DblClick(Sender: TObject);
  private
    { Private declarations }
   ViewBitmap: TBitmap;
   ImageIndex,PreviewImageHeight,PreviewImageWidth,MetafileCount: Integer;
   LoadingMetafiles,LoadAgain: Boolean;
   Zoomfactor,ZoomStep: Double;
   Persistent: TMetafile;
  public
    { Public declarations }
   StartPage, EndPage,PreviewPaperHeight,PreviewPaperWidth: Integer;
   procedure FillImagelist;
  end;

var
  RichPreviewForm: TRichPreviewForm;

implementation

{$R *.DFM}

procedure TRichPreviewForm.FormClose(Sender: TObject; var Action: TCloseAction);
var I: Integer;
    FileTyp: file of TMetafile;
    FileNameMetafile,FileNameMetafileExt: string;
begin
 ViewBitmap.free;
 Persistent.free;
 For I:=0 to MetafileCount do
 begin
  str(I,FileNameMetafileExt);
  FileNameMetafile:='PreviewMetafile'+FileNameMetafileExt;
  AssignFile(FileTyp,FileNameMetafile);
  {$I-}
  RESET(FileTyp);
 {$I+}
  IF IOResult=0 then
  begin
   CloseFile(FileTyp);
   Erase(FileTyp);
  end;
 end;
 Action:=caFree;
end;

procedure TRichPreviewForm.FillImagelist;
var FileNameMetafile,FileNameMetafileExt: string;
begin
 MetaFileCanvasRichPrint.free;
 str(ImageIndex,FileNameMetafileExt);
 FileNameMetafile:='PreviewMetafile'+FileNameMetafileExt;
{showmessage('FileNameMetafile='+FileNameMetafile);}
 MetafileRichPrint.SaveToFile(FileNameMetafile);
 MetafileRichPrint.free;
 MetafileCount:=ImageIndex;
 ImageIndex:=ImageIndex+1;
end;

procedure TRichPreviewForm.FormCreate(Sender: TObject);
var ZoomText: String;
begin
 PreviewImageHeight:=round(0.95*Screen.Height);
 Height:=PreviewImageHeight;
 ClientHeight:=Height-27;
 if RatioPage <> 0 then PreviewImageWidth:=round((0.98*ClientHeight-71)/RatioPage) else
                        PreviewImageWidth:=round(0.707*(0.98*ClientHeight-71));   {A4 format}
 if round(1.0204*PreviewImageWidth) > Screen.Width then
 begin
  PreviewImageHeight:=round(Screen.Width/1.0204*PreviewImageWidth*PreviewImageHeight);
  PreviewImageWidth:=round(0.98*Screen.Width);
 end;
 Height:=PreviewImageHeight;
 ClientHeight:=Height-27;

 ImageIndex:=0;
 Width:=round(1.0204*PreviewImageWidth);
 ClientWidth:=Width-8;

 if ClientWidth < 395+round(0.02*ClientWidth) Then {in order to function with a screen resolution of 800*600 or even lower}
 begin                                             {preferable the resolution should be 1024*768}
  Width:=round(1.0204*(395+0.02*ClientWidth));
  ClientWidth:=Width-8;
 end;

 Image1.Top:=round(0.01*ClientHeight);
 Image1.Left:=round(0.01*ClientWidth);
 Image1.Height:=round(0.98*ClientHeight)-71;
 Image1.Width:=round(0.98*ClientWidth);
 ScrollBox1.Top:=Image1.Top;
 ScrollBox1.Left:=Image1.Left;
 ScrollBox1.Height:=Image1.Height;
 ScrollBox1.Width:=Image1.Width;
 Panel1.Top:=Image1.Top+Image1.Height;
 Panel1.Left:=Image1.Left;
 Panel1.Width:=Image1.Width;

 ViewBitmap:=TBitmap.Create;
 ViewBitmap.Height:=Image1.Height;
 ViewBitmap.Width:=Image1.Width;
 Image1.Picture.Graphic:=ViewBitmap;
 LoadingMetafiles:=true;
 Zoomfactor:=1;
 ZoomStep:=0.1;
 str(ZoomStep:5:3,ZoomText);
 MaskEdit1.Text:=ZoomText;
 str(ZoomFactor:5:3,ZoomText);
 Label7.Caption:=ZoomText;
 LoadAgain:=true;
 Persistent:=TMetafile.Create;
end;

procedure TRichPreviewForm.FormPaint(Sender: TObject);
var PageText: string;
    ShowMetafile: TMetafile;
    FileNameMetafile,FileNameMetafileExt: string;
    DrawRect: TRect;
    FileTyp: file of TMetafile;
    ClearBitmap: TBitmap;

procedure Scrolling;
begin
 if Zoomfactor > 1.00001 then
 begin
  with Scrollbox1 do
  begin
   HorzScrollBar.Range:=Round(Zoomfactor*ScrollBox1.Width);
   VertScrollBar.Range:=Round(Zoomfactor*ScrollBox1.Height);
   Image1.Width:=HorzScrollBar.Range;
   Image1.Height:=VertScrollBar.Range;
  end;
 end
else
 begin
  with Scrollbox1 do
  begin
   HorzScrollBar.Range:=0;
   VertScrollBar.Range:=0;
   Image1.Width:=ScrollBox1.Width;
   Image1.Height:=ScrollBox1.Height;
  end;
 end;
 Image1.Picture.Bitmap.Width:=Image1.Width;
 Image1.Picture.Bitmap.Height:=Image1.Height;
end;

begin
 if LoadingMetafiles then str(ImageIndex-1,FileNameMetafileExt) else str(ImageIndex,FileNameMetafileExt);
 FileNameMetafile:='PreviewMetafile'+FileNameMetafileExt;
 AssignFile(FileTyp,FileNameMetafile);
 {$I-}
 RESET(FileTyp);
 {$I+}
 IF IOResult=0 then
 begin
  CloseFile(FileTyp);
  ShowMetafile:=TMetafile.Create;
  if LoadAgain then
  begin
   ShowMetafile.LoadFromfile(FileNameMetafile);
   Persistent.Assign(ShowMetafile);
  end else ShowMetafile.Assign(Persistent);
  Scrolling;
  DrawRect.Top:=0;
  DrawRect.Left:=0;
  DrawRect.Right:=Image1.Width;
  DrawRect.Bottom:=Image1.Height;
  ClearBitmap:=TBitmap.Create;
  ClearBitmap.Width:=Image1.Width;
  ClearBitmap.Height:=Image1.Height;
  Image1.Picture.Bitmap.Canvas.Draw(0,0,ClearBitmap);
  Image1.Picture.Bitmap.Canvas.StretchDraw(DrawRect,ShowMetafile);
{  Image1.Picture.Bitmap.Canvas.Draw(0,0,ShowMetafile);}
  ClearBitmap.free;
  if LoadingMetafiles then STR(ImageIndex:4,PageText) else STR(ImageIndex+1:4,PageText);
  Label5.Caption:=PageText;
  Image1.Refresh;
  ShowMetafile.free;
 end;
end;

procedure TRichPreviewForm.BitBtn1Click(Sender: TObject);
begin
 Close;
end;

procedure TRichPreviewForm.ArrowButton2Click(Sender: TObject);
begin
 LoadingMetafiles:=false;
 LoadAgain:=true;
 ImageIndex:=ImageIndex+1;
 if ImageIndex > MetafileCount Then ImageIndex:=MetafileCount;
 if ImageIndex=MetafileCount then
 begin
  ArrowButton1.Enabled:=true;
  Label2.Enabled:=true;
  Label9.Enabled:=true;
  ArrowButton2.Enabled:=false;
  Label1.Enabled:=false;
  Label3.Enabled:=false;
 end
else
 begin
  ArrowButton1.Enabled:=true;
  Label2.Enabled:=true;
  Label9.Enabled:=true;
  ArrowButton2.Enabled:=true;
  Label1.Enabled:=true;
  Label3.Enabled:=true;
 end;
 FormPaint(Sender);
end;

procedure TRichPreviewForm.ArrowButton1Click(Sender: TObject);
begin
 if ImageIndex > MetafileCount Then ImageIndex:=MetafileCount;
 LoadingMetafiles:=false;
 LoadAgain:=true;
 ImageIndex:=ImageIndex-1;
 if ImageIndex < 0 Then ImageIndex:=0;
 if ImageIndex=0 then
 begin
  ArrowButton1.Enabled:=false;
  Label2.Enabled:=false;
  Label9.Enabled:=false;
  ArrowButton2.Enabled:=true;
  Label1.Enabled:=true;
  Label3.Enabled:=true;
 end
else
 begin
  ArrowButton1.Enabled:=true;
  Label2.Enabled:=true;
  Label9.Enabled:=true;
  ArrowButton2.Enabled:=true;
  Label1.Enabled:=true;
  Label3.Enabled:=true;
 end;
 FormPaint(Sender);
end;

procedure TRichPreviewForm.SpeedButton1Click(Sender: TObject);
var Index: Integer;
    Rectangle: TRect;
    FileNameMetafile,FileNameMetafileExt: string;
    PrintMetafile: TMetafile;
    FileTyp: file of TMetafile;
begin
 LoadingMetafiles:=false;
 LoadAgain:=true;
 Screen.Cursor:=crHourGlass;
 PrintDialog1.FromPage:=1;
 PrintDialog1.ToPage:=MetafileCount+1;
 PrintDialog1.MinPage:=1;
 PrintDialog1.MaxPage:=MetafileCount+1;
 if PrintDialog1.Execute then
 begin
  if PrintDialog1.PrintRange=prAllPages then
  begin
   StartPage:=1;
   EndPage:=PrintDialog1.MaxPage;
  end;
  if PrintDialog1.PrintRange=prPageNums then
  begin
   StartPage:=PrintDialog1.FromPage;
   EndPage:=PrintDialog1.ToPage;
  end;
  PrintMetafile:=TMetafile.Create;
  Rectangle.Top:=0;
  Rectangle.Left:=0;
  Rectangle.Right:=PreviewPaperWidth;
  Rectangle.Bottom:=PreviewPaperHeight;
  for Index:=StartPage-1 to EndPage-1 do
  begin
   ImageIndex:=Index;
   FormPaint(Sender);

   str(Index,FileNameMetafileExt);
   FileNameMetafile:='PreviewMetafile'+FileNameMetafileExt;
   AssignFile(FileTyp,FileNameMetafile);
   {$I-}
   RESET(FileTyp);
    {$I+}
   IF IOResult=0 then
   begin
    CloseFile(FileTyp);
    PrintMetafile.LoadFromfile(FileNameMetafile);
    Printer.BeginDoc;
    Printer.Canvas.StretchDraw(Rectangle,PrintMetafile);
    Printer.EndDoc;
   end;
  end;
  PrintMetafile.free;
 end;
 Screen.Cursor:=crDefault;
end;


procedure TRichPreviewForm.SpeedButton2Click(Sender: TObject);
var ZoomText: string;
begin
 LoadAgain:=false;
 if ImageIndex > MetafileCount Then ImageIndex:=MetafileCount;
 if ImageIndex=0 then LoadingMetafiles:=false else LoadingMetafiles:=true;
 Zoomfactor:=Zoomfactor+Zoomstep;
 str(Zoomfactor:5:3,ZoomText);
 Label7.Caption:=ZoomText;
 if Zoomfactor > 1 then SpeedButton3.Enabled:=true;
 FormPaint(Sender);
end;

procedure TRichPreviewForm.SpeedButton3Click(Sender: TObject);
var ZoomText: string;
begin
 LoadAgain:=false;
 if ImageIndex > MetafileCount Then ImageIndex:=MetafileCount;
 Zoomfactor:=Zoomfactor-Zoomstep;
 if Zoomfactor < 1 then Zoomfactor:=1;
 if Zoomfactor=1 then SpeedButton3.Enabled:=false else SpeedButton3.Enabled:=true;
 str(Zoomfactor:5:3,ZoomText);
 Label7.Caption:=ZoomText;
 FormPaint(Sender);
end;

procedure TRichPreviewForm.MaskEdit1Change(Sender: TObject);
var Code: Integer;
begin
 val(MaskEdit1.Text,Zoomstep,Code);
 if Code <> 0 then ZoomStep:=0.1;
end;

procedure TRichPreviewForm.Image1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var ZoomText: string;
begin
 If Button=mbRight then
 begin
  Zoomfactor:=1;
  str(Zoomfactor:5:3,ZoomText);
  Label7.Caption:=ZoomText;
  SpeedButton3.Enabled:=false;
  FormPaint(Sender);
 end;
end;

procedure TRichPreviewForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 LoadingMetafiles:=false;
 case Key of
  33: ArrowButton2Click(Sender);
  34: ArrowButton1Click(Sender);
  35: begin
       ImageIndex:=MetafileCount;
       Label1.Enabled:=false;
       Label3.Enabled:=false;
       Label2.Enabled:=true;
       Label9.Enabled:=true;
       FormPaint(Sender);
       end;
  36: begin
       ImageIndex:=0;
       Label1.Enabled:=true;
       Label3.Enabled:=true;
       Label2.Enabled:=false;
       Label9.Enabled:=false;
       FormPaint(Sender);
      end;
  38: with Scrollbox1 do VertScrollBar.Position:=VertScrollBar.Position-VertScrollBar.Increment;
  40: with Scrollbox1 do VertScrollBar.Position:=VertScrollBar.Position+VertScrollBar.Increment;
  37: with Scrollbox1 do HorzScrollBar.Position:=HorzScrollBar.Position-HorzScrollBar.Increment;
  39: with Scrollbox1 do HorzScrollBar.Position:=HorzScrollBar.Position+HorzScrollBar.Increment;
 end;
end;

procedure TRichPreviewForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
 LoadingMetafiles:=false;
 case Key of
  'l','L': SpeedButton2Click(Sender);
  's','S': SpeedButton3Click(Sender);
  'p','P': SpeedButton1Click(Sender);
 end;
end;

procedure TRichPreviewForm.Label7DblClick(Sender: TObject);
var ZoomText: string;
begin
 Zoomfactor:=1;
 str(Zoomfactor:5:3,ZoomText);
 Label7.Caption:=ZoomText;
 SpeedButton3.Enabled:=false;
 FormPaint(Sender);
end;

end.
